Index: code/trunk/src/orxonox/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/CMakeLists.txt	(revision 1206)
+++ code/trunk/src/orxonox/CMakeLists.txt	(revision 1209)
@@ -55,4 +55,6 @@
   ${OGRE_LIBRARIES}
   ${Lua_LIBRARIES}
+  tinyxml
+  tolualib
   util
   core
Index: code/trunk/src/orxonox/OrxonoxStableHeaders.h
===================================================================
--- code/trunk/src/orxonox/OrxonoxStableHeaders.h	(revision 1206)
+++ code/trunk/src/orxonox/OrxonoxStableHeaders.h	(revision 1209)
@@ -95,6 +95,6 @@
 #include "util/SubString.h"
 //#include "util/XMLIncludes.h"
-#include "util/tinyxml/ticpp.h"
-#include "util/tinyxml/tinyxml.h"
+#include "tinyxml/ticpp.h"
+#include "tinyxml/tinyxml.h"
 
 #include "core/BaseObject.h"
Index: code/trunk/src/orxonox/objects/Ambient.cc
===================================================================
--- code/trunk/src/orxonox/objects/Ambient.cc	(revision 1206)
+++ code/trunk/src/orxonox/objects/Ambient.cc	(revision 1209)
@@ -35,5 +35,5 @@
 #include <OgreSceneManager.h>
 
-#include "util/tinyxml/tinyxml.h"
+#include "tinyxml/tinyxml.h"
 #include "util/SubString.h"
 #include "util/Convert.h"
Index: code/trunk/src/orxonox/objects/Camera.cc
===================================================================
--- code/trunk/src/orxonox/objects/Camera.cc	(revision 1206)
+++ code/trunk/src/orxonox/objects/Camera.cc	(revision 1209)
@@ -37,5 +37,5 @@
 #include <OgreViewport.h>
 
-#include "util/tinyxml/tinyxml.h"
+#include "tinyxml/tinyxml.h"
 #include "util/SubString.h"
 #include "util/Convert.h"
Index: code/trunk/src/orxonox/objects/Model.cc
===================================================================
--- code/trunk/src/orxonox/objects/Model.cc	(revision 1206)
+++ code/trunk/src/orxonox/objects/Model.cc	(revision 1209)
@@ -30,5 +30,5 @@
 #include "Model.h"
 
-#include "util/tinyxml/tinyxml.h"
+#include "tinyxml/tinyxml.h"
 #include "core/CoreIncludes.h"
 #include "GraphicsEngine.h"
Index: code/trunk/src/orxonox/objects/Skybox.cc
===================================================================
--- code/trunk/src/orxonox/objects/Skybox.cc	(revision 1206)
+++ code/trunk/src/orxonox/objects/Skybox.cc	(revision 1209)
@@ -34,5 +34,5 @@
 #include <OgreSceneManager.h>
 
-#include "util/tinyxml/tinyxml.h"
+#include "tinyxml/tinyxml.h"
 #include "GraphicsEngine.h"
 #include "core/CoreIncludes.h"
Index: code/trunk/src/orxonox/objects/SpaceShip.cc
===================================================================
--- code/trunk/src/orxonox/objects/SpaceShip.cc	(revision 1206)
+++ code/trunk/src/orxonox/objects/SpaceShip.cc	(revision 1209)
@@ -38,5 +38,5 @@
 #include <OgreSceneNode.h>
 
-#include "util/tinyxml/tinyxml.h"
+#include "tinyxml/tinyxml.h"
 #include "util/Convert.h"
 #include "util/Math.h"
Index: code/trunk/src/orxonox/objects/WorldEntity.cc
===================================================================
--- code/trunk/src/orxonox/objects/WorldEntity.cc	(revision 1206)
+++ code/trunk/src/orxonox/objects/WorldEntity.cc	(revision 1209)
@@ -33,5 +33,5 @@
 #include <sstream>
 
-#include "util/tinyxml/tinyxml.h"
+#include "tinyxml/tinyxml.h"
 #include "util/SubString.h"
 #include "core/CoreIncludes.h"
Index: code/trunk/src/orxonox/objects/weapon/AmmunitionDump.cc
===================================================================
--- code/trunk/src/orxonox/objects/weapon/AmmunitionDump.cc	(revision 1206)
+++ code/trunk/src/orxonox/objects/weapon/AmmunitionDump.cc	(revision 1209)
@@ -32,5 +32,5 @@
 #include "orxonox/Orxonox.h"
 #include "BulletManager.h"
-#include "util/tinyxml/tinyxml.h"
+#include "tinyxml/tinyxml.h"
 #include "core/CoreIncludes.h"
 
Index: code/trunk/src/orxonox/objects/weapon/BulletManager.h
===================================================================
--- code/trunk/src/orxonox/objects/weapon/BulletManager.h	(revision 1206)
+++ code/trunk/src/orxonox/objects/weapon/BulletManager.h	(revision 1209)
@@ -38,5 +38,5 @@
 
 #include "network/Synchronisable.h"
-#include "util/tinyxml/tinyxml.h"
+#include "tinyxml/tinyxml.h"
 #include "core/BaseObject.h"
 #include "core/Tickable.h"